#!/usr/bin/python
#BrlTex
#Copyright (C) 2006-2007 Michael Whapples, All Rights Reserved.
#Original Author: Michael Whapples, mwhapples@users.sourceforge.net
#Unless linsor has explicitly granted you any other licensing terms, the contents of this file is subject to the RPL 
1.1, 
#available at the BrlTex website (http://brltex.sourceforge.net).
#All software distributed under the Licenses is provided strictly on an "AS IS" basis,
#WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND the licensor
#HEREBY DISCLAIMS ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
#OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT, OR NON-INFRINGEMENT.
#Licensor reserves the right to change the Venue stated in the license to the UK.

#from plasTeX.TeX import TeX
import getopt, sys, globalvars
import os
try:
	brltex_dir = os.path.dirname(__file__)
except:
	brltex_dir = os.path.dirname(sys.executable)
globalvars.brltex_dir = brltex_dir
sys.path.insert(0, brltex_dir)
from plasTeX.TeX import TeX
def usagemsg():
	print('''BrlTex by Michael Whapples\n
BrlTex version 0.0.1-beta

Usage:\tBrlTex (opts) inputfile
Options:
-c {code}\tUse {code} for braille output
-l {linelength}\tNumber of cells perlines, default 40
-p {pagelength}\tNumber of lines per page, default 22''')
try:
	opts, args = getopt.getopt(sys.argv[1:], 'c:l:p:h', ['code=', 
'linelength=', 'pagelength=', 'help'])
except getopt.GetoptError:
	usagemsg
	sys.exit(2)
if len(args) == 1:
	infilename = args[0]
else:
	usagemsg()
	sys.exit(2)
brlcode = 'bauk'
linelength = 40
pagelength = 25
for o, a in opts:
	if o == "-c":
		print(a)
		brlcode = a
	elif o == '-h':
		usagemsg()
		sys.exit(2)
	elif o == '-l':
		try:
			linelength = int(a)
		except:
			print('Line length must be an integer')
			sys.exit(2)
	elif o == '-p':
		try:
			pagelength = int(a)
		except:
			print('Page length must be an integer')
			sys.exit(2)
#import os
olddir = os.getcwd()
os.chdir(brltex_dir)
exec('from %s import Renderer, transdata' % brlcode)
if linelength > 20 and pagelength > 10:
	exec('transdata.pagelen = pagelength\ntransdata.linelen = linelength')
else:
	print('linelength must be above 20 and pagelength must be above 10')
	sys.exit(2)
os.chdir(olddir)
if infilename[-4:].lower().find('.tex') < 0:
	Print('This does not seem to be a .tex file')
	sys.exit()
if not os.path.exists(infilename):
	print('Cannot find %s' % infilename)
	sys.exit()
f = open(infilename)
texstr = f.read()
f.close()
#Preprocess the LaTex
import preprocess
texstr = preprocess.latex_preprocess(texstr)
#A dictionary of those unicode values not readable
#Now to include certain LaTex that should be avoided by PlasTeX, e.g. ^\infinty
#subchars = {'\x92': "'", '\x96': '-', '\x93': '"', '\x94': '"', '\x85': '...', '\x91': '"',
#'^\\infty': '^{\\infty}', '^\\cdot': '^\\cdot'}
#subchars = {}
#f = open(os.path.join(brltex_dir, 'latex_correct.subs'))
#for line in f:
#	if len(line.split('\t')) != 2 or line[0] == r'#':
#		continue
#	else:
#		#if 'char' in line.split('\t')[2]:
#		exec("subchars.update({'%s': line.split('\t')[1][:-1]})" 
#% line.split('\t')[0])
#		#else:
#		#subchars.update({line.split()[0]: line.split()[1]})
#f.close()
#import re
##Now replace them
#for charkey, charval in subchars.items():
#	#texstr = texstr.replace(charkey, charval)
#	texstr = re.sub(charkey, charval, texstr)
#print texstr[2455:2500]
#locateval = texstr.find('a\x80')
#print(texstr[locateval:locateval + 20])
#dumpfile = open('error.dump', 'w')
#dumpfile.write(texstr[locateval - 5:locateval + 5])
#dumpfile.close()
#locateval = input('how is it')
outfilename = infilename[:-4] + '.brf'
tex = TeX()
tex.ownerDocument.config['files']['filename'] = outfilename
tex.ownerDocument.config['files']['split-level'] = -100
tex.ownerDocument.config['files']['escape-high-chars']=True
tex.ownerDocument.config['files']['output-encoding'] = 'utf_8'
tex.input(texstr)
import macros
tex.ownerDocument.context.update(macros.macroDict)
tex.ownerDocument.config['document']['toc-non-files'] = True
tex.ownerDocument.config['document']['toc-depth'] = 4
document = tex.parse()
Renderer().render(document)
