#!/usr/bin/python
#Copyright (C) 2006-2007 Michael Whapples, All Rights Reserved.
#Original Author: Michael Whapples, mwhapples@users.sourceforge.net
#Unless linsor has explicitly granted you any other licensing terms, the contents of this file is subject to the RPL 
#1.1, 
#available at the BrlTex website (http://brltex.sourceforge.net).
#All software distributed under the Licenses is provided strictly on an "AS IS" basis,
#WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND the licensor
#HEREBY DISCLAIMS ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
#OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT, OR NON-INFRINGEMENT.
#Licensor reserves the right to change the Venue stated in the license to the UK.

#This outputs in the computer braille code,
#so in libbraille, the american table should be used

#Some stuff for later on
#A dictionary for lowered numbers, such as those used in denominators
#This is not really needed for BAUK, but this will aid if other codes don't use the what is defined below.
#Not the best variable name, some with a better imagination, suggestion?
lownum = {'1': '1', '2': '2', '3': '3', '4': '4', '5': '5', '6': '6', '7': '7', '8': '8', '9': '9', '0': '0'}
#need the normal number chars
highnum = {'1': 'a', '2': 'b', '3': 'c', '4': 'd', '5': 'e', '6': 'f', '7': 'g', '8': 'h', '9': 'i', '0': 'j'}
#also need a number prefix
numprefix = '#'
#a function to do number conversion.
def numtrans(numint):
        numstr = str(numint)
        outtext = numprefix
        for x in numstr:
                outtext += highnum[x]
        return outtext

#A function to convert lower numbers (added by Alasstair Irving)
def lownumtrans(numint):
        numstr = str(numint)
        outtext=""
        for x in numstr:
                outtext += lownum[x]
        return outtext

#This is a new version of translate.py, it will attempt to use liblouis for the translator.
import os
import string
import sys
import liblouis
#This function will sometime become the only translator function as liblouis allows for custom tables
#This will require writing the tables and modifying this function to accept the mode so the table can be called
def grade1(inputtext, transtbl="en-uk-g2.ctb"):
	outtext = liblouis.translate(inputtext, transtbl)
	return  outtext
#The text translator
def text(inputtext):
	if string.punctuation.find(inputtext[0]) != -1:
		return ',%s' % grade1(inputtext, "en-uk-g2.ctb")
	else:
		return grade1(inputtext, "en-uk-g2.ctb")
#the math text translator
def math(inputtext, compact=False):
	#This has some code trying to translate it, but now liblouis is used, it should be possible to use that
	#It could prove better to write a table for that
	#comment out the appropiate line depending if you wish to use liblouis
	outtext = grade1(inputtext, 'en-uk-math.ctb')
	#outtext = math2brl(inputtext, compact)
	outtext = outtext.replace(';,', ',')
	#if outtext[0] == ';':
		#outtext = outtext[1:]
	return outtext
#We will try and do a translator for the text of math mode
#This should be simple, as there are no contractions, and about everything is a simple substitution.
#It is currently being done as a seperate function to math as this will allow testing without affecting the current 
#situation
#We will need some chars that should not have a space after
mathnospaf = '''([{+=-/| '''
#Now for before
mathnospbf = ''')]'}/| '''
mathpreferspbf = '=+-'
#mathops is the operators that have dot-56 prefixes and do not need them if follows another of mathops
mathops = ['+', '-', '=']
mathsimpletrans = {'+': ';6', '=': ';7', '-': ';-', "'": '9', '(': '<', ')': '>', '<': '[', '>': 'O', '[': '(', ']': 
')', '|': '_', '!': '6'}
def math2brl(inputtext, compact=False):
	outtext = ''
	prevchar = ''
	prevprevchar = ''
	nextchar = ''
	for x, character in enumerate(inputtext):
		#Now get prevprevchar, prevchar and nextchar
		if (x -2) >= 0:
			prevprevchar = inputtext[x-2]
		if (x - 1) >= 0:
			prevchar = inputtext[x-1]
		if (x + 1) < len(inputtext):
			nextchar = inputtext[x+1]
		else:
			nextchar = ''
		#Find unnecessary spaces
		if character.isspace() and (mathnospaf.find(prevchar) >=0) and (prevchar != ''):
			continue
		elif character.isspace() and (mathnospbf.find(nextchar) >= 0):
			continue
		#Now for character translation
		elif mathsimpletrans.has_key(character):
			if (mathpreferspbf.find(character) >= 0) and (not compact) and (mathnospaf.find(prevchar) < 0):
				outtext += ' %s' % mathsimpletrans[character]
			else:
				if (character in mathops) and (prevchar in mathops):
					outtext += mathsimpletrans[character][1:]
				elif (character in mathops) and prevchar.isspace() and (not outtext[-1].isspace()) and (prevprevchar in mathops):
					outtext += mathsimpletrans[character][1:]
				else:
					outtext += mathsimpletrans[character]
		elif character.isupper() and nextchar.isupper() and (not prevchar.isupper()):
			outtext += ',,%s' % character
		elif (not prevchar.isupper()) and character.isupper() and (not nextchar.isupper()):
			outtext += ',%s' % character
		elif ((not prevchar.isdigit()) and (prevchar != '.')) and character.isdigit():
			outtext += numprefix + highnum[character]
		elif ((prevchar == '.') or prevchar.isdigit()) and character.isdigit():
			outtext += highnum[character]
		elif prevchar.isdigit() and (character == '.') and nextchar.isdigit():
			outtext += '1'
		elif prevchar.isdigit() and (character.islower() and character.isalpha):
			outtext += ';%s' % character
		else:
			outtext += character
	return outtext
def brlStop():
	liblouis.lou_free()
