#!/usr/bin/python
#Copyright (C) 2006-2007 Michael Whapples, All Rights Reserved.
#Original Author: Michael Whapples, mwhapples@users.sourceforge.net
#Unless linsor has explicitly granted you any other licensing terms, the contents of this file is subject to the RPL
#1.1,
#available at the BrlTex website (http://brltex.sourceforge.net).
#All software distributed under the Licenses is provided strictly on an "AS IS" basis,
#WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND the licensor
#HEREBY DISCLAIMS ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
#OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT, OR NON-INFRINGEMENT.
#Licensor reserves the right to change the Venue stated in the license to the UK.

from ctypes import *
import os, globalvars, sys
#olddir = os.getcwd()
#os.chdir(os.path.dirname(__file__))
brl = ''

def find_liblouis():
	global brl
	try:
		try:
			try:
				brl = windll.LoadLibrary(os.path.join(globalvars.brltex_dir, 'liblouis', 'liblouis.dll'))
			except NameError:
				brl = cdll.LoadLibrary(os.path.join(globalvars.brltex_dir, 'liblouis', 'liblouis.so'))
		except OSError:
			brl = cdll.LoadLibrary(os.path.join(globalvars.brltex_dir, 'liblouis', 'liblouis.dylib'))
	except:
		import ctypes.util
		lou_name = ctypes.util.find_library('louis')
		if lou_name == None:
			print('You have no suitable version of liblouis. BrlTex can try to compile you a copy.')
			from liblouis_compile import compile
			if not compile():
				print('BrlTex has been unable to compile you a version of liblouis. Please try to compile it manually and put the dynamic library in the liblouis directory of BrlTex.')
				sys.exit()
			return False
		else:
			brl = cdll.LoadLibrary(lou_name)
	if brl == None:
		return False
	return True
if not find_liblouis():
	if not find_liblouis():
		print('Unable to load liblouis, make sure that it has been correctly installed.')
		sys.exit()

#os.chdir(olddir)
def translate(transstr, transtbl="en-uk-g2.ctb"):
	#olddir = os.getcwd()
	#os.chdir(os.path.dirname(__file__))
	if transtbl.find(os.path.sep) == -1:
		transtbl = os.path.join(globalvars.brltex_dir, 'liblouis', transtbl)
	#s = create_unicode_buffer(transstr)
	#inlen = len(s)
	#numofbytes = sizeof(s)/inlen
	#if numofbytes != 2:
	#	s = cast(s, POINTER(c_ubyte))
	#	x = 0
	#	inbuf = (c_ubyte * 2 * inlen)()
	#	bytetrack = 0
	#	while x < (inlen * numofbytes):
	#		if bytetrack < 1:
	#			inbuf[(x/numofbytes) + bytetrack] = (c_ubyte * 2)(s[x], s[x+1])
	#		bytetrack += 1
	#		x += 1
	#		if bytetrack == numofbytes:
	#			bytetrack = 0
	#else:
	#	inbuf = s
	s = unicode(transstr)
	s = s.encode('utf16')[2:]
	inlen = len(transstr)
	inbuf = create_string_buffer(s)
	outsize = inlen * 6
	out = (c_char * outsize)()
	outlen = c_int(sizeof(out))
	inlen = c_int(inlen)
	brl.lou_translateString(transtbl, inbuf, byref(inlen), out, byref(outlen), None, None, 0)
	#os.chdir(olddir)
	try:
		outbrl = unicode('\xff\xfe' + out[0:outlen.value * 2], 'utf16')
	except:
		outbrl = unicode('\xff\xfe' + out[0:outlen.value * 2] + '\x00', 'utf16')
		#sys.exit()
	return outbrl
def lou_free():
	brl.lou_free()
