#!/usr/bin/python
from ctypes import *
try:
	_braille = cdll.LoadLibrary('braille.dll')
except OSError:
	import ctypes.util
	_braille = cdll.LoadLibrary(ctypes.util.find_library('braille'))
except:
	exit()
braille_init = _braille.braille_init
braille_close = _braille.braille_close
braille_display = _braille.braille_display
braille_config = _braille.braille_config
braille_size = _braille.braille_size
braille_drivernum = _braille.braille_drivernum
def braille_drivername(drivernum):
	return string_at(_braille.braille_drivername(drivernum))
#braille_drivername = _braille.braille_drivername
def braille_drivermodels(drivernum):
	return string_at(_braille.braille_drivermodels(drivernum))
#braille_drivermodels = _braille.braille_drivermodels
braille_tablenum = _braille.braille_tablenum
def braille_tablename(tablenum):
	return string_at(_braille.braille_tablename(tablenum))
#braille_tablename = _braille.braille_tablename
def braille_tabledesc(tablenum):
	return string_at(_braille.braille_tabledesc(tablenum))
#braille_tabledesc = _braille.braille_tabledesc
def braille_info(infonum):
	return string_at(_braille.braille_info(infonum))
#braille_info = _braille.braille_info
braille_timeout = _braille.braille_timeout
def braille_read(key):
	return _braille.braille_read(byref(key))
#braille_read = _braille.braille_read
braille_write = _braille.braille_write
braille_filter = _braille.braille_filter
braille_render = _braille.braille_render
def braille_geterror():
	return string_at(_braille.braille_geterror())
#braille_geterror = _braille.braille_geterror

BRLK_SLASH = 47
BRLK_SCROLLOCK = 302
BRLK_LAST = 439
BRLK_z = 122
BRLK_ACCORD_z = 436
BRLK_WORLD_47 = 207
BRLK_KP_DIVIDE = 267
BRL_PATHCONF = 8
BRLK_EXCLAIM = 33
BRLK_AT = 64
BRLK_MENU = 319
BRLK_ACCORD_h = 418
BRLK_F5 = 286
BRLK_WORLD_75 = 235
BRLK_p = 112
BRLK_WORLD_64 = 224
BRLK_SPACE = 32
BRLK_F3 = 284
BRLK_BACKSPACE = 8
BRLK_k = 107
BRLK_ACCORD_k = 421
BRLK_WORLD_92 = 252
BRLK_BACKWARD = 401
BRLK_1 = 49
BRLK_LSHIFT = 304
BRLK_WORLD_37 = 197
BRLK_KP_MINUS = 269
BRLK_ACCORD_x = 434
BRLK_WORLD_17 = 177
BRLK_v = 118
BRLK_CLEAR = 12
BRLK_WORLD_94 = 254
BRLK_m = 109
BRLK_ACCORD_m = 423
BRLK_WORLD_34 = 194
BRLK_PAGEUP = 280
BRLK_NUMLOCK = 300
BRL_TYPE_SPECIAL = 1
BRLK_3 = 51
BRLK_LCTRL = 306
BRLK_WORLD_2 = 162
BRLK_ACCORD_u = 431
BRLK_KP_ENTER = 271
BRLK_WORLD_91 = 251
BRLK_CARET = 94
BRLK_FORWARD = 402
BRLK_WORLD_31 = 191
BRLK_DELETE = 127
BRLK_WORLD_19 = 179
BRLK_HASH = 35
BRLK_UNKNOWN = 0
BRLK_PAUSE = 19
BRLK_WORLD_62 = 222
BRLK_o = 111
BRLK_ACCORD_o = 425
BRLK_WORLD_36 = 196
BRLK_ACCORD_r = 428
BRLK_5 = 53
BRLK_LALT = 308
BRLK_d = 100
BRLK_WORLD_4 = 164
BRLK_ACCORD_q = 427
BRLK_WORLD_53 = 213
BRLK_WORLD_51 = 211
BRLK_F15 = 296
BRLK_WORLD_21 = 181
BRLK_F9 = 290
BRL_CMD = 3
BRLK_q = 113
BRLK_ABOVE = 437
BRLK_7 = 55
BRLK_WORLD_6 = 166
BRLK_WORLD_66 = 226
BRLK_LEFTBRACKET = 91
BRLK_l = 108
BRLK_RIGHT = 275
BRLK_x = 120
BRLK_b = 98
BRLK_ACCORD_b = 412
BRLK_RMETA = 309
BRLK_WORLD_23 = 183
BRLK_WORLD_83 = 243
BRLK_LEFTPAREN = 40
BRLK_F11 = 292
BRLK_QUOTEDBL = 34
BRLK_WORLD_46 = 206
BRLK_s = 115
BRLK_ACCORD_s = 429
BRLK_WORLD_40 = 200
BRLK_KP4 = 260
BRL_DRIVER = 1
BRLK_ASTERISK = 42
BRLK_9 = 57
BRLK_RSUPER = 312
BRL_TYPE_USB = 4
BRLK_WORLD_8 = 168
BRLK_WORLD_68 = 228
BRLK_ACCORD_i = 419
BRLK_WORLD_57 = 217
BRLK_INSERT = 277
BRL_CURSOR = 2
BRLK_ACCORD_d = 414
BRLK_KP_PERIOD = 266
BRLK_WORLD_85 = 245
BRLK_GREATER = 62
BRLK_F13 = 294
BRLK_KP9 = 265
BRLK_u = 117
BRLK_KP6 = 262
BRL_TABLE = 3
BRLK_e = 101
BRLK_UP = 273
BRLK_SEMICOLON = 59
BRLK_COMPOSE = 314
BRLK_WORLD_10 = 170
BRLK_WORLD_70 = 230
BRLK_KP7 = 263
BRLK_WORLD_59 = 219
BRLK_END = 279
BRL_ACC = 4
BRLK_f = 102
BRLK_ACCORD_f = 416
BRLK_WORLD_27 = 187
BRL_DEVICE = 0
BRLK_COMMA = 44
BRL_PATHTBL = 7
BRLK_w = 119
BRLK_ACCORD_w = 433
BRLK_WORLD_44 = 204
BRLK_KP8 = 264
BRL_VERSION = 5
BRLK_a = 97
BRLK_WORLD_60 = 220
BRLK_EQUALS = 61
BRLK_WORLD_63 = 223
BRLK_ACCORD_a = 411
BRLK_WORLD_61 = 221
BRLK_PAGEDOWN = 281
BRLK_h = 104
BRLK_KP2 = 258
BRLK_WORLD_29 = 189
BRLK_WORLD_49 = 209
BRLK_CAPSLOCK = 301
BRLK_KP1 = 257
BRLK_y = 121
BRLK_ACCORD_y = 435
BRLK_KP0 = 256
BRLK_WORLD_38 = 198
BRLK_WORLD_14 = 174
BRLK_WORLD_74 = 234
BRLK_WORLD_95 = 255
BRLK_F2 = 283
BRLK_NONE = 0
BRLK_j = 106
BRLK_ACCORD_j = 420
BRLK_EURO = 321
BRLK_SYSREQ = 317
BRLK_0 = 48
BRLK_RSHIFT = 303
BRLK_WORLD_30 = 190
BRLK_WORLD_48 = 208
BRLK_KP_MULTIPLY = 268
BRLK_QUESTION = 63
BRLK_POWER = 320
BRLK_WORLD_79 = 239
BRLK_WORLD_16 = 176
BRLK_WORLD_76 = 236
BRLK_WORLD_28 = 188
BRLK_F4 = 285
BRLK_TAB = 9
BRLK_ACCORD_l = 422
BRLK_WORLD_90 = 250
BRLK_WORLD_93 = 253
BRL_PATHDRV = 6
BRL_TYPE_UNKNOWN = 0
BRLK_2 = 50
BRLK_RCTRL = 305
BRLK_WORLD_1 = 161
BRLK_WORLD_89 = 249
BRLK_WORLD_50 = 210
BRLK_KP_PLUS = 270
BRLK_RIGHTBRACKET = 93
BRLK_WORLD_25 = 185
BRLK_PRINT = 316
BRLK_WORLD_18 = 178
BRLK_WORLD_78 = 238
BRLK_F6 = 287
BRLK_WORLD_87 = 247
BRLK_RETURN = 13
BRLK_n = 110
BRLK_ACCORD_n = 424
BRLK_WORLD_35 = 195
BRL_NONE = 0
BRL_TYPE_SERIAL = 2
BRLK_4 = 52
BRLK_RALT = 307
BRLK_WORLD_22 = 182
BRLK_KP_EQUALS = 272
BRLK_UNDERSCORE = 95
BRLK_DOT7 = 403
BRLK_BACKQUOTE = 96
BRLK_WORLD_15 = 175
BRLK_DOLLAR = 36
BRLK_LMETA = 310
BRLK_ESCAPE = 27
BRLK_ACCORD_p = 426
BRLK_WORLD_82 = 242
BRLK_WORLD_88 = 248
BRLK_6 = 54
BRLK_WORLD_5 = 165
BRLK_WORLD_81 = 241
BRLK_WORLD_54 = 214
BRLK_DOWN = 274
BRLK_WORLD_80 = 240
BRLK_QUOTE = 39
BRLK_F10 = 291
BRLK_r = 114
BRLK_WORLD_39 = 199
BRLK_KP3 = 259
BRLK_DOT8 = 404
BRLK_LSUPER = 311
BRLK_WORLD_7 = 167
BRLK_WORLD_67 = 227
BRLK_WORLD_42 = 202
BRLK_WORLD_77 = 237
BRLK_WORLD_56 = 216
BRLK_LEFT = 276
BRL_KEY = 1
BRLK_c = 99
BRLK_ACCORD_c = 413
BRLK_WORLD_32 = 192
BRLK_WORLD_13 = 173
BRLK_WORLD_24 = 184
BRLK_WORLD_84 = 244
BRLK_RIGHTPAREN = 41
BRLK_PERIOD = 46
BRLK_t = 116
BRLK_ACCORD_t = 430
BRLK_WORLD_41 = 201
BRLK_KP5 = 261
BRL_TERMINAL = 2
BRLK_MINUS = 45
BRLK_COLON = 58
BRLK_MODE = 313
BRLK_WORLD_9 = 169
BRLK_WORLD_69 = 229
BRLK_WORLD_73 = 233
BRLK_WORLD_58 = 218
BRLK_HOME = 278
BRLK_ACCORD_e = 415
BRLK_WORLD_72 = 232
BRLK_F8 = 289
BRLK_BELOW = 438
BRLK_WORLD_26 = 186
BRLK_WORLD_86 = 246
BRLK_PLUS = 43
BRLK_WORLD_52 = 212
BRLK_WORLD_0 = 160
BRLK_F14 = 295
BRLK_ACCORD_v = 432
BRLK_WORLD_43 = 203
BRL_PATH = 4
BRLK_WORLD_55 = 215
BRLK_LESS = 60
BRLK_HELP = 315
BRLK_WORLD_11 = 171
BRLK_WORLD_71 = 231
BRLK_F12 = 293
BRLK_g = 103
BRLK_ACCORD_g = 417
BRLK_WORLD_12 = 172
BRLK_AMPERSAND = 38
BRLK_WORLD_45 = 205
BRLK_WORLD_20 = 180
BRLK_BACKSLASH = 92
BRLK_WORLD_3 = 163
BRLK_WORLD_33 = 193
BRLK_WORLD_65 = 225
BRLK_F1 = 282
BRLK_i = 105
BRLK_BREAK = 318
BRLK_F7 = 288
BRLK_8 = 56

# values for enumeration 'brl_keytype'
brl_keytype = c_int # enum
class brl_key(Structure):
    pass

# values for enumeration 'brl_keycode'
brl_keycode = c_int # enum
brl_key._fields_ = [
    ('type', brl_keytype),
    ('braille', c_ubyte),
    ('code', brl_keycode),
    ('unicode', c_ushort),
]
assert sizeof(brl_key) == 16, sizeof(brl_key)
assert alignment(brl_key) == 4, alignment(brl_key)

# values for enumeration 'brl_config'
brl_config = c_int # enum

# values for enumeration 'brl_drivertype'
brl_drivertype = c_int # enum
__all__ = ['BRLK_BELOW', 'BRLK_RETURN', 'BRLK_RSUPER', 'BRLK_WORLD_0',
           'BRLK_KP_PERIOD', 'BRLK_LEFTPAREN', 'BRLK_AT',
           'BRLK_LCTRL', 'BRLK_HOME', 'brl_keytype', 'BRLK_i',
           'BRLK_ACCORD_v', 'BRLK_ACCORD_w', 'BRLK_ACCORD_t',
           'BRLK_ACCORD_u', 'BRLK_ACCORD_r', 'BRLK_ACCORD_s',
           'BRLK_ACCORD_p', 'BRLK_ACCORD_q', 'BRLK_COMPOSE',
           'BRLK_ACCORD_z', 'BRLK_F6', 'BRLK_ACCORD_x', 'BRLK_SLASH',
           'BRLK_ACCORD_f', 'BRLK_WORLD_34', 'BRLK_WORLD_37',
           'BRLK_WORLD_36', 'BRLK_ACCORD_b', 'BRLK_WORLD_30',
           'BRLK_WORLD_33', 'BRLK_ACCORD_a', 'BRLK_ACCORD_n',
           'BRLK_ACCORD_o', 'BRLK_ACCORD_l', 'BRLK_ACCORD_m',
           'BRLK_ACCORD_j', 'BRLK_ACCORD_k', 'BRLK_ACCORD_h',
           'BRLK_ACCORD_i', 'BRLK_WORLD_65', 'BRLK_LAST',
           'BRLK_WORLD_15', 'BRLK_KP_MULTIPLY', 'BRL_CURSOR',
           'BRLK_WORLD_93', 'BRLK_WORLD_92', 'BRLK_WORLD_91',
           'BRLK_F4', 'BRLK_CARET', 'BRLK_WORLD_95', 'BRLK_WORLD_94',
           'BRLK_KP_ENTER', 'BRLK_WORLD_69', 'BRL_CMD', 'BRLK_NONE',
           'BRLK_BACKSLASH', 'BRLK_c', 'BRLK_F9', 'BRLK_F12',
           'BRLK_ACCORD_c', 'BRL_DEVICE', 'BRLK_UNKNOWN',
           'BRLK_MINUS', 'BRLK_F1', 'BRLK_HELP', 'BRLK_WORLD_26',
           'BRLK_WORLD_27', 'BRLK_WORLD_24', 'BRLK_HASH',
           'BRLK_WORLD_22', 'BRLK_WORLD_23', 'BRLK_WORLD_20',
           'BRLK_WORLD_21', 'BRLK_WORLD_28', 'BRLK_WORLD_29',
           'BRLK_WORLD_84', 'BRLK_WORLD_85', 'BRLK_WORLD_86',
           'BRLK_ABOVE', 'BRLK_WORLD_80', 'BRLK_WORLD_81',
           'BRLK_EQUALS', 'BRLK_WORLD_83', 'BRLK_SYSREQ',
           'BRLK_KP_DIVIDE', 'BRLK_WORLD_88', 'BRLK_WORLD_89',
           'BRLK_WORLD_67', 'BRLK_POWER', 'BRLK_EXCLAIM',
           'BRLK_WORLD_13', 'BRLK_QUOTEDBL', 'BRLK_WORLD_8',
           'BRLK_KP1', 'BRLK_KP0', 'BRLK_LALT', 'BRLK_KP2',
           'BRLK_KP5', 'BRLK_KP4', 'BRLK_KP7', 'BRLK_KP6', 'BRLK_KP9',
           'BRLK_KP8', 'BRLK_RIGHTBRACKET', 'BRLK_F3', 'BRLK_FORWARD',
           'BRLK_WORLD_11', 'BRLK_WORLD_10', 'BRLK_WORLD_17',
           'BRLK_RMETA', 'BRLK_F5', 'BRLK_WORLD_14', 'BRLK_RALT',
           'BRLK_WORLD_12', 'BRLK_WORLD_19', 'BRLK_WORLD_18',
           'BRLK_KP_PLUS', 'brl_keycode', 'BRLK_PLUS', 'BRL_TYPE_USB',
           'BRLK_ASTERISK', 'BRL_ACC', 'BRLK_PERIOD', 'BRLK_NUMLOCK',
           'BRLK_WORLD_39', 'BRLK_DOT8', 'BRLK_LEFTBRACKET',
           'BRLK_ESCAPE', 'BRLK_F8', 'brl_key', 'BRLK_DOT7',
           'BRLK_BACKWARD', 'BRLK_COMMA', 'BRLK_SPACE', 'BRL_PATHDRV',
           'BRLK_QUOTE', 'BRLK_WORLD_73', 'BRL_VERSION',
           'BRLK_RSHIFT', 'BRLK_l', 'BRLK_m', 'BRLK_n', 'BRLK_o',
           'BRLK_h', 'BRLK_LSHIFT', 'BRLK_j', 'BRLK_k', 'BRLK_d',
           'BRLK_e', 'BRLK_f', 'BRLK_g', 'BRLK_a', 'BRLK_b',
           'BRL_TYPE_SPECIAL', 'BRLK_WORLD_87', 'BRLK_x', 'BRLK_y',
           'BRLK_z', 'BRLK_t', 'BRLK_u', 'BRLK_v', 'BRLK_w', 'BRLK_p',
           'BRLK_q', 'BRLK_r', 'BRLK_s', 'BRLK_WORLD_79',
           'BRLK_WORLD_78', 'BRL_TABLE', 'BRLK_WORLD_82',
           'BRLK_CAPSLOCK', 'BRLK_WORLD_71', 'BRLK_WORLD_70',
           'BRLK_UP', 'BRLK_WORLD_72', 'BRLK_WORLD_75',
           'BRLK_ACCORD_d', 'BRLK_WORLD_77', 'BRLK_WORLD_76',
           'BRLK_WORLD_16', 'BRLK_ACCORD_e', 'BRLK_PRINT',
           'BRLK_WORLD_31', 'BRLK_INSERT', 'BRLK_F14', 'BRLK_LMETA',
           'BRLK_RCTRL', 'BRL_PATH', 'BRLK_WORLD_32', 'BRLK_WORLD_7',
           'BRLK_WORLD_6', 'BRLK_WORLD_5', 'BRLK_WORLD_4',
           'BRLK_WORLD_3', 'BRLK_WORLD_2', 'BRLK_WORLD_1', 'BRL_NONE',
           'BRLK_4', 'BRLK_5', 'BRLK_6', 'BRLK_7', 'BRLK_0', 'BRLK_1',
           'BRLK_2', 'BRLK_3', 'BRLK_LSUPER', 'BRLK_F15',
           'BRLK_WORLD_25', 'BRLK_F13', 'BRLK_WORLD_74', 'BRLK_F11',
           'BRLK_F10', 'BRLK_WORLD_62', 'BRLK_WORLD_63',
           'BRLK_WORLD_60', 'BRLK_WORLD_61', 'BRLK_WORLD_66',
           'BRLK_UNDERSCORE', 'BRLK_WORLD_64', 'BRLK_WORLD_38',
           'BRL_KEY', 'BRL_PATHTBL', 'BRLK_GREATER', 'brl_drivertype',
           'BRLK_WORLD_35', 'BRLK_TAB', 'BRLK_KP3', 'BRLK_END',
           'BRLK_MENU', 'BRLK_EURO', 'BRLK_ACCORD_y', 'BRLK_F7',
           'BRLK_PAGEUP', 'BRLK_BACKQUOTE', 'BRLK_WORLD_9',
           'BRLK_PAGEDOWN', 'BRL_DRIVER', 'BRL_TYPE_UNKNOWN',
           'BRLK_QUESTION', 'BRLK_PAUSE', 'BRLK_SCROLLOCK',
           'BRLK_WORLD_56', 'BRLK_WORLD_55', 'BRLK_WORLD_54',
           'BRLK_WORLD_53', 'BRLK_WORLD_52', 'BRLK_WORLD_51',
           'BRLK_WORLD_50', 'BRLK_SEMICOLON', 'BRLK_WORLD_68',
           'BRLK_WORLD_59', 'BRLK_WORLD_58', 'BRLK_RIGHT',
           'BRLK_AMPERSAND', 'BRL_TYPE_SERIAL', 'BRLK_F2',
           'BRLK_CLEAR', 'BRLK_DELETE', 'BRLK_WORLD_57',
           'BRLK_WORLD_90', 'BRLK_ACCORD_g', 'BRLK_KP_EQUALS',
           'BRL_TERMINAL', 'BRLK_BACKSPACE', 'BRLK_LESS',
           'BRLK_KP_MINUS', 'BRLK_MODE', 'BRLK_DOWN', 'BRLK_WORLD_40',
           'BRLK_WORLD_41', 'BRLK_WORLD_42', 'BRLK_WORLD_43',
           'BRLK_WORLD_44', 'BRLK_WORLD_45', 'BRLK_WORLD_46',
           'BRLK_WORLD_47', 'BRLK_WORLD_48', 'BRLK_WORLD_49',
           'BRLK_BREAK', 'brl_config', 'BRLK_8', 'BRLK_LEFT',
           'BRLK_DOLLAR', 'BRL_PATHCONF', 'BRLK_COLON',
           'BRLK_RIGHTPAREN', 'BRLK_9', 'braille_init', 'braille_close', 'braille_display', 'braille_read', 
'braille_timeout', 'braille_write', 'braille_filter', 'braille_render', 'braille_drivernum', 'braille_drivername', 
'braille_drivermodels', 'braille_tablenum', 'braille_tablename', 'braille_tabledesc', 'braille_config', 
'braille_geterror', 'braille_size']
