from distutils.core import setup
import py2exe
import os.path, sys	
sys.path.insert(0, os.path.dirname(__file__))
def getfiles(basedir):
	dirlist = []
	for myfile in os.listdir(basedir):
		myfile2 = os.path.join(basedir, myfile)
		if os.path.isdir(myfile2) and myfile != '.svn':
			dirlist.extend(getfiles(myfile2))
		if os.path.isfile(myfile2) and (myfile2[-3:] != '.py' and myfile2[-4:] != '.pyc'):
			dirlist.append((os.path.dirname(myfile2), [myfile2]))
	return dirlist

import compileall
compileall.compile_dir('plasTeX', force=True)
plasTeX_files = getfiles('plasTeX')
liblouis_files = [('liblouis', ['liblouis\\liblouis.dll', 'liblouis\\en-uk-g1.ctb', 'liblouis\\en-uk-g2.ctb', 'liblouis\\en-uk-math.ctb', 'liblouis\\chardefs.cti', 'liblouis\\countries.cti', 'liblouis\\text.nabcc.dis', 'liblouis\\text_nabcc.dis', 'liblouis\\en-uk-verbatim.ctb'])]
bauk_files = [('bauk', ['bauk\\simple.subs'])]
misc_files = [('', ['latex_correct.subs', 'test.tex'])]
datafiles = plasTeX_files 
datafiles.extend(liblouis_files)
datafiles.extend(bauk_files)
datafiles.extend(misc_files)
setup(console=['BrlTex.py', 'BrlView.py'],
options = {'py2exe':{'packages':['bauk', 'plasTeX', 'plasTeX.DOM', 'plasTeX.ConfigManager', 'plasTeX.Base'], 'optimize':2}}, 
data_files=datafiles)
